#ifndef EFL_GENERATED_EVAS_SMART_CLIPPED_HH
#define EFL_GENERATED_EVAS_SMART_CLIPPED_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "canvas/evas_smart_clipped.eo.h"
}

#include "canvas/evas_smart.eo.hh"

struct evas_smart_clipped
      : evas_smart
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_smart_clipped(Eo* eo)
      : evas_smart(eo)
   {}

   evas_smart_clipped(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_smart_clipped(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_smart_clipped(evas_smart_clipped const& other)
      : evas_smart(eo_ref(other._eo_ptr()))
   {}

   ~evas_smart_clipped() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_OBJ_SMART_CLIPPED_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EVAS_OBJ_SMART_CLIPPED_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_smart_clipped >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::evas_smart_clipped >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_smart_clipped>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::evas_smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_smart_clipped, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::evas_smart_clipped>
{
   template <typename T>
   struct type
   {
      operator ::evas_smart_clipped() const
      {
         return ::evas_smart_clipped(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_smart_clipped>)
{
   return (EVAS_OBJ_SMART_CLIPPED_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_SMART_CLIPPED_HH

